
object APair {

  def create[T<:Addable[T],U<:Addable[U]] (f:T,s:U):APair[T,U] = 
    new APairImpl[T,U](f,s)


  private class APairImpl[T <: Addable[T],U <: Addable[U]] (f:T,s:U) 
                                                    extends APair[T,U] {

    def first ():T = f
    def second ():U = s

    def add (i:APair[T,U]):APair[T,U] = 
      new APairImpl(f.add(i.first()),s.add(i.second()))

    // canonical methods?

    override def toString ():String = 
      "(" + f.toString() + "," + s.toString() + ")"
  }
}


abstract class APair[T <: Addable[T],U <: Addable[U]] 
                                         extends Addable[APair[T,U]] {

  def first ():T
  def second ():U

  def add (p:APair[T,U]):APair[T,U]
}
