
object PairInt {

  def create (f:Int,s:Int):PairInt = new PairImpl(f,s)


  private class PairImpl (f:Int,s:Int) extends PairInt {

    def first ():Int = f
    def second ():Int = s

    def add (i:PairInt):PairInt = 
      new PairImpl(f+i.first(),s+i.second())

    // canonical methods?

    override def toString ():String = "(" + f + "," + s + ")"
  }

}



abstract class PairInt extends Addable[PairInt] {

  def first ():Int
  def second ():Int

  def add (p:PairInt):PairInt
}
